Newer
Older
# (C) Copyright 2012 Jason A. Donenfeld <Jason@zx2c4.com>. All Rights Reserved.
# This is released under the GPLv2+. Please see COPYING for more information.
PREFIX="${PASSWORD_STORE_DIR:-$HOME/.password-store}"
GPG_OPTS="--quiet --yes --batch"
export GIT_DIR="$GIT"
export GIT_WORK_TREE="$PREFIX"
version() {
cat <<_EOF
|-----------------------|
| Password Store |
| by zx2c4 |
| |
| Jason@zx2c4.com |
| Jason A. Donenfeld |
|-----------------------|
_EOF
}
Initialize new password storage and use gpg-id for encryption.
$program [show] [--clip,-c] pass-name
Show existing password and optionally put it on the clipboard.
If put on the clipboard, it will be cleared in 45 seconds.
$program insert [--no-echo,-n | --multiline,-m] [--force,-f] pass-name
Insert new password. Optionally, the console can be enabled to not
echo the password back. Or, optionally, it may be multiline. Prompt
before overwriting existing password unless forced.
$program edit pass-name
Insert a new password or edit an existing password using ${EDITOR:-vi}.
$program generate [--no-symbols,-n] [--clip,-c] pass-name pass-length
Generate a new password of pass-length with optionally no symbols.
Optionally put it on the clipboard and clear board after 45 seconds.
If the password store is a git repository, push the latest changes.
If the password store is a git repository, pull the latest changes.
$program git git-command-args...
If the password store is a git repository, execute a git command
specified by git-command-args.
$program version
Show version information.
init|ls|list|show|insert|edit|generate|remove|rm|delete|push|pull|git|help|--help|version|--version) return 0 ;;
*) return 1 ;;
esac
}
clip() {
# This base64 business is a disgusting hack to deal with newline inconsistancies
# in shell. There must be a better way to deal with this, but because I'm a dolt,
# we're going with this for now.
before="$(xclip -o -selection clipboard | base64)"
echo -n "$1" | xclip -selection clipboard
(
now="$(xclip -o -selection clipboard | base64)"
if [[ $now != $(echo -n "$1" | base64) ]]; then
before="$now"
fi
# It might be nice to programatically check to see if klipper exists,
# as well as checking for other common clipboard managers. But for now,
# this works fine. Clipboard managers frequently write their history
# out in plaintext, so we axe it here.
qdbus org.kde.klipper /klipper org.kde.klipper.klipper.clearClipboardHistory >/dev/null 2>&1
echo "$before" | base64 -d | xclip -selection clipboard
) & disown
echo "Copied $2 to clipboard. Will clear in 45 seconds."
}
command="$1"
if isCommand "$command"; then
shift
else
command="show"
case "$command" in
init)
if [[ $# -ne 1 ]]; then
echo "Usage: $program $command gpg-id"
exit 1
fi
gpg_id="$1"
mkdir -v -p "$PREFIX"
echo "$gpg_id" > "$ID"
echo "Password store initialized for $gpg_id."
version|--version)
version
exit 0
;;
echo " $program init your-gpg-id"
echo "before you may use the password store."
echo
usage
exit 1
else
ID="$(head -n 1 "$ID")"
fi
opts="$(getopt -o c -l clip -n $program -- "$@")"
err=$?
eval set -- "$opts"
while true; do case $1 in
-c|--clip) clip=1; shift ;;
--) shift; break ;;
esac done
if [[ $err -ne 0 ]]; then
echo "Usage: $program $command [--clip,-c] [pass-name]"
exit 1
path="$1"
if [[ -d $PREFIX/$path ]]; then
if [[ $path == "" ]]; then
echo "Password Store"
else
echo $path
fi
tree --noreport "$PREFIX/$path" | tail -n +2 | sed 's/\(.*\)\.gpg$/\1/'
else
passfile="$PREFIX/$path.gpg"
if ! [[ -f $passfile ]]; then
echo "$path is not in the password store."
exit 1
fi
if [ $clip -eq 0 ]; then
clip "$(gpg -d $GPG_OPTS "$passfile" | head -n 1)" "$path"
force=0
opts="$(getopt -o mnf -l multiline,no-echo,force -n $program -- "$@")"
err=$?
eval set -- "$opts"
while true; do case $1 in
-f|--force) force=1; shift ;;
if [[ $err -ne 0 || ( $multiline -eq 1 && $noecho -eq 1 ) || $# -ne 1 ]]; then
echo "Usage: $program $command [--no-echo,-n | --multiline,-m] [--force,-f] pass-name"
if [[ $force -eq 0 && -e $passfile ]]; then
prompt="An entry already exists for $path. Overwrite it [y/N]? "
read -p "$prompt" yesno
[[ $yesno == "y" || $yesno == "Y" ]] || exit 1
fi
mkdir -p -v "$PREFIX/$(dirname "$path")"
echo "Enter contents of $path and press Ctrl+D when finished:"
echo
cat | gpg -e -r "$ID" -o "$passfile" $GPG_OPTS
read -p "Enter password for $path: " -s password
read -p "Retype password for $path: " -s password_again
echo
if [[ $password == $password_again ]]; then
gpg -e -r "$ID" -o "$passfile" $GPG_OPTS <<<"$password"
break
else
echo "Error: the entered passwords do not match."
fi
done
else
read -p "Enter password for $path: " -e password
gpg -e -r "$ID" -o "$passfile" $GPG_OPTS <<<"$password"
fi
if [[ -d $GIT ]]; then
git add "$passfile"
git commit -m "Added given password for $path to store."
fi
;;
edit)
if [[ $# -ne 1 ]]; then
exit 1
fi
path="$1"
mkdir -p -v "$PREFIX/$(dirname "$path")"
passfile="$PREFIX/$path.gpg"
trap 'rm -rf "$tmp_dir" "$tmp_file"' INT TERM EXIT
if [[ -d /dev/shm && -w /dev/shm && -x /dev/shm ]]; then
tmp_dir="$(TMPDIR=/dev/shm mktemp -t $template -d)"
prompt=$(echo "Your system does not have /dev/shm, which means that it may"
echo "be difficult to entirely erase the temporary non-encrypted"
echo "password file after editing. Are you sure you would like to"
echo -n "continue? [y/N] ")
read -p "$prompt" yesno
[[ $yesno == "y" || $yesno == "Y" ]] || exit 1
tmp_file="$(TMPDIR="$tmp_dir" mktemp -t $template)"
action="Added"
if [[ -f $passfile ]]; then
gpg -d -o "$tmp_file" $GPG_OPTS "$passfile" || exit 1
while ! gpg -e -r "$ID" -o "$passfile" $GPG_OPTS "$tmp_file"; do
echo "GPG encryption failed. Retrying."
sleep 1
done
if [[ -d $GIT ]]; then
git add "$passfile"
git commit -m "$action password for $path using ${EDITOR:-vi}."
fi
;;
generate)
clip=0
symbols="-y"
opts="$(getopt -o nc -l no-symbols,clip -n $program -- "$@")"
err=$?
eval set -- "$opts"
while true; do case $1 in
-n|--no-symbols) symbols=""; shift ;;
-c|--clip) clip=1; shift ;;
--) shift; break ;;
esac done
if [[ $err -ne 0 || $# -ne 2 ]]; then
echo "Usage: $program $command [--no-symbols,-n] [--clip,-c] pass-name pass-length"
exit 1
fi
path="$1"
length="$2"
if ! [[ $length =~ ^[0-9]+$ ]]; then
echo "pass-length \"$length\" must be a number."
exit 1
fi
mkdir -p -v "$PREFIX/$(dirname "$path")"
pass="$(pwgen -s $symbols $length 1)"
passfile="$PREFIX/$path.gpg"
gpg -e -r "$ID" -o "$passfile" $GPG_OPTS <<<"$pass"
if [[ -d $GIT ]]; then
git add "$passfile"
git commit -m "Added generated password for $path to store."
fi
if [ $clip -eq 0 ]; then
echo "The generated password to $path is:"
echo "$pass"
else
clip "$pass" "$path"
fi
;;
if [[ $# -ne 1 ]]; then
echo "Usage: $program $command pass-name"
fi
path="$1"
passfile="$PREFIX/$path.gpg"
if ! [[ -f $passfile ]]; then
echo "$path is not in the password store."
exit 1
fi
rm -i -v "$passfile"
git rm -f "$passfile"
git commit -m "Removed $path from store."
fi
;;
push|pull)
if [[ -d $GIT ]]; then
else
echo "Error: the password store is not a git repository."
exit 1
fi
;;
else
echo "Error: the password store is not a git repository."
exit 1
fi
;;